<?
/**
 * TRIBUNAL REGIONAL FEDERAL DA 4 REGIO
 *
 * 14/03/2017 - criado por pedro.cast
 *
 * Verso do Gerador de Cdigo: 1.40.0
 */

require_once dirname(__FILE__) . '/../../../SEI.php';

class MdPetIntRelDestinatarioDTO extends InfraDTO {

	private $AceiteTIPOFK = null;
	private $ProcedimentoDocTIPOFK = null;

	public function __construct(){
		$this->AceiteTIPOFK = InfraDTO::$TIPO_FK_OPCIONAL;
		$this->ProcedimentoDocTIPOFK = InfraDTO::$TIPO_FK_OPCIONAL;
		parent::__construct();
	}

	public function getStrNomeTabela() {
		return 'md_pet_int_rel_dest';
	}

	public function montar() {

		$this->adicionarAtributoTabela(InfraDTO::$PREFIXO_NUM, 'IdMdPetIntRelDestinatario', 'id_md_pet_int_rel_dest');

		$this->adicionarAtributoTabela(InfraDTO::$PREFIXO_STR, 'SinAtivo', 'sin_ativo');

		$this->adicionarAtributoTabela(InfraDTO::$PREFIXO_STR, 'SinPessoaJuridica', 'sin_pessoa_juridica');

		$this->adicionarAtributoTabela(InfraDTO::$PREFIXO_NUM, 'IdMdPetIntimacao', 'id_md_pet_intimacao');

		$this->adicionarAtributoTabela(InfraDTO::$PREFIXO_NUM, 'IdContato', 'id_contato');

		$this->adicionarAtributoTabela(InfraDTO::$PREFIXO_DTH, 'DataCadastro', 'data_cadastro');

		$this->adicionarAtributoTabela(InfraDTO::$PREFIXO_NUM, 'IdAcessoExterno', 'id_acesso_externo');

		$this->adicionarAtributoTabela(InfraDTO::$PREFIXO_NUM, 'IdUnidade', 'id_unidade');

		$this->adicionarAtributoTabela(InfraDTO::$PREFIXO_STR, 'StaSituacaoIntimacao', 'sta_situacao_intimacao');

		//Atts Gerais
		$this->adicionarAtributo(InfraDTO::$PREFIXO_DTH,'DataFinal');
		$this->adicionarAtributo(InfraDTO::$PREFIXO_STR,'Anexos');
		$this->adicionarAtributo(InfraDTO::$PREFIXO_STR,'SituacaoIntimacao');
		$this->adicionarAtributo(InfraDTO::$PREFIXO_STR,'DocumentoPrincipal');
		$this->adicionarAtributo(InfraDTO::$PREFIXO_NUM,'IdSituacaoIntimacao');

		//PK
		$this->configurarPK('IdMdPetIntRelDestinatario',InfraDTO::$TIPO_PK_NATIVA);

		/// Configs Fks
		$this->configurarFK('IdAcessoExterno', 'acesso_externo a', 'a.id_acesso_externo', InfraDTO::$TIPO_FK_OPCIONAL);
		$this->configurarFK('IdAcessoExterno', 'md_pet_acesso_externo mpa', 'mpa.id_acesso_externo', InfraDTO::$TIPO_FK_OPCIONAL);

		$this->configurarFK('IdMdPetIntimacao', 'md_pet_intimacao mpi', 'mpi.id_md_pet_intimacao');
		$this->configurarFK('IdContato', 'contato c', 'c.id_contato');
		$this->configurarFK('IdMdPetIntimacao', 'md_pet_int_protocolo mpd', 'mpd.id_md_pet_intimacao');
		$this->configurarFK('IdProtocolo','protocolo pd','pd.id_protocolo');
		$this->configurarFK('IdDocumento', 'documento d', 'd.id_documento', $this->getProcedimentoDocTIPOFK());
		$this->configurarFK('IdSerie', 'serie s', 's.id_serie');
		$this->configurarFK('IdProtocoloProcedimento', 'protocolo pp', 'pp.id_protocolo');
		$this->configurarFK('IdMdPetTipoIntimacao', 'md_pet_int_tipo_intimacao mpit', 'mpit.id_md_pet_int_tipo_intimacao');
		$this->configurarFK('IdProcedimento', 'procedimento pro', 'pro.id_procedimento');
		$this->configurarFK('IdTipoProcedimento', 'tipo_procedimento tpro', 'tpro.id_tipo_procedimento');
		$this->configurarFK('IdMdPetIntRelDestinatario', 'md_pet_int_aceite aceite', 'aceite.id_md_pet_int_rel_dest', $this->getAceiteTIPOFK(), InfraDTO::$FILTRO_FK_WHERE );
		$this->configurarFK('IdUnidade', 'unidade uint', 'uint.id_unidade');
		$this->configurarFK('IdAtividadeAcessoExterno', 'atividade atv', 'atv.id_atividade', InfraDTO::$TIPO_FK_OPCIONAL);
		$this->configurarFK('IdUnidadeAcessoExterno', 'unidade u', 'u.id_unidade', InfraDTO::$TIPO_FK_OPCIONAL);


		//Add Atr

		//Acesso Externo
		$this->adicionarAtributoTabelaRelacionada(InfraDTO::$PREFIXO_DTA, 'ValidadeAcessoExterno', 'a.dta_validade', 'acesso_externo a');
		
		//Acesso Externo do Mdulo
		$this->adicionarAtributoTabelaRelacionada(InfraDTO::$PREFIXO_STR, 'SinAtivoModulo', 'mpa.sin_ativo', 'md_pet_acesso_externo mpa');
	
		//Atividade do Acesso Externo
		$this->adicionarAtributoTabelaRelacionada(InfraDTO::$PREFIXO_NUM, 'IdAtividadeAcessoExterno','a.id_atividade','acesso_externo a');

		//Unidade da Atividade do Acesso Externo
		$this->adicionarAtributoTabelaRelacionada(InfraDTO::$PREFIXO_NUM, 'IdUnidadeAcessoExterno','atv.id_unidade','atividade atv');

		//Unidade da Intimao
		$this->adicionarAtributoTabelaRelacionada(InfraDTO::$PREFIXO_STR, 'SiglaUnidadeIntimacao','uint.sigla','unidade uint');
		$this->adicionarAtributoTabelaRelacionada(InfraDTO::$PREFIXO_STR, 'DescricaoUnidadeIntimacao','uint.descricao','unidade uint');

		//Intimao
		$this->adicionarAtributoTabelaRelacionada(InfraDTO::$PREFIXO_NUM, 'IdMdPetIntimacaoMdPetIntimacao', 'mpi.id_md_pet_intimacao', 'md_pet_intimacao mpi');
		$this->adicionarAtributoTabelaRelacionada(InfraDTO::$PREFIXO_NUM, 'IdMdPetTipoIntimacao','mpi.id_md_pet_int_tipo_intimacao','md_pet_intimacao mpi');

		//Tipo de Intimao
		$this->adicionarAtributoTabelaRelacionada(InfraDTO::$PREFIXO_STR, 'NomeTipoIntimacao','mpit.nome','md_pet_int_tipo_intimacao mpit');
		$this->adicionarAtributoTabelaRelacionada(InfraDTO::$PREFIXO_STR, 'NomeTipoRespostaAceita','mpit.tipo_resposta_aceita','md_pet_int_tipo_intimacao mpit');

		//Contato
		$this->adicionarAtributoTabelaRelacionada(InfraDTO::$PREFIXO_STR, 'NomeContato', 'c.nome','contato c');
		$this->adicionarAtributoTabelaRelacionada(InfraDTO::$PREFIXO_STR, 'EmailContato', 'c.email','contato c');

		// Intimao x Protocolo
		$this->adicionarAtributoTabelaRelacionada(InfraDTO::$PREFIXO_DBL, 'IdProtocolo', 'mpd.id_protocolo', 'md_pet_int_protocolo mpd');
		$this->adicionarAtributoTabelaRelacionada(InfraDTO::$PREFIXO_STR, 'SinPrincipalDoc', 'mpd.sin_principal', 'md_pet_int_protocolo mpd');

		//Protocolo Processo
		$this->adicionarAtributoTabelaRelacionada(InfraDTO::$PREFIXO_STR, 'ProtocoloFormatadoProcedimento','pp.protocolo_formatado','protocolo pp');
		$this->adicionarAtributoTabelaRelacionada(InfraDTO::$PREFIXO_STR, 'EspecificacaoProcedimento','pp.descricao','protocolo pp');

		//Protocolo Documento
		$this->adicionarAtributoTabelaRelacionada(InfraDTO::$PREFIXO_DBL, 'IdDocumento', 'pd.id_protocolo', 'protocolo pd');
		$this->adicionarAtributoTabelaRelacionada(InfraDTO::$PREFIXO_STR, 'ProtocoloFormatadoDocumento','pd.protocolo_formatado','protocolo pd');

		//Documento
		$this->adicionarAtributoTabelaRelacionada(InfraDTO::$PREFIXO_NUM, 'IdSerie','d.id_serie','documento d');
		$this->adicionarAtributoTabelaRelacionada(InfraDTO::$PREFIXO_DBL, 'IdProtocoloProcedimento','d.id_procedimento','documento d');
		$this->adicionarAtributoTabelaRelacionada(InfraDTO::$PREFIXO_DBL, 'IdProcedimento','d.id_procedimento','documento d');
		$this->adicionarAtributoTabelaRelacionada(InfraDTO::$PREFIXO_STR, 'Numero','d.numero','documento d');

		//Serie
		$this->adicionarAtributoTabelaRelacionada(InfraDTO::$PREFIXO_STR, 'NomeSerie','s.nome','serie s');

		//Procedimento
		$this->adicionarAtributoTabelaRelacionada(InfraDTO::$PREFIXO_NUM, 'IdTipoProcedimento','pro.id_tipo_procedimento','procedimento pro');

		//Tipo Procedimento
		$this->adicionarAtributoTabelaRelacionada(InfraDTO::$PREFIXO_STR, 'NomeTipoProcedimento','tpro.nome','tipo_procedimento tpro');

		//Aceite
		$this->adicionarAtributoTabelaRelacionada(InfraDTO::$PREFIXO_DTH, 'DataAceite','aceite.data','md_pet_int_aceite aceite');
		$this->adicionarAtributoTabelaRelacionada(InfraDTO::$PREFIXO_STR, 'TipoAceite','aceite.tipo_aceite','md_pet_int_aceite aceite');

	}

	public function getAceiteTIPOFK() {
		return $this->AceiteTIPOFK;
	}

	public function setAceiteTIPOFK($AceiteTIPOFK) {
		$this->AceiteTIPOFK = $AceiteTIPOFK;
	}

	public function getProcedimentoDocTIPOFK() {
		return $this->ProcedimentoDocTIPOFK;
	}

	public function setProcedimentoDocTIPOFK($ProcedimentoDocTIPOFK) {
		$this->ProcedimentoDocTIPOFK = $ProcedimentoDocTIPOFK;
	}

}
?>